from dlpc230.commands import *
from time import sleep

#last edited date: May 16, 2019 
#last editor: Muhammad Rajabali

#---------------------------------------------
#user settings
#---------------------------------------------
loglevel = 1
gains = [TiaGain.Gain0p75,TiaGain.Gain1p5,TiaGain.Gain3,TiaGain.Gain6,TiaGain.Gain9,TiaGain.Gain12,TiaGain.Gain18,TiaGain.Gain24,TiaGain.Gain36,TiaGain.Gain48,TiaGain.Gain72] #,TiaGain.Gain96,TiaGain.Gain144,TiaGain.Gain288]
min_DM_illumbin = 7
max_illumbin = 11
interval_time = 0.05
percentage_increment = 20
current_limit_margin_percentage = 20
max_current_limit = 800
sync_period = 119
round_up_to_nearest_number = 5
#----------------------------------------------



#--------------------------------------------------------------------------------------
#Global Constants -- DO NOT MODIFY 
#--------------------------------------------------------------------------------------
percent = float((100-float(percentage_increment))/100)
margin_percent = float(float(current_limit_margin_percentage)/100.0)
LEDDriveError = {True : "Error", False : "No Error"}
results = ["Cannot use", "Can use with sync", "Can use without sync"]
#--------------------------------------------------------------------------------------


def round_up_to_nearest(round_to, red_CL, green_CL, blue_CL):
    red_CL = int(red_CL + (round_to - (red_CL % round_to)))
    green_CL = int(green_CL + (round_to - (green_CL % round_to)))
    blue_CL = int(blue_CL + (round_to - (blue_CL % round_to)))
    if red_CL > max_current_limit:
        red_CL = max_current_limit
    if green_CL > max_current_limit:
        green_CL = max_current_limit
    if blue_CL > max_current_limit:
        blue_CL = max_current_limit    
    return int(green_CL), int(red_CL), int(blue_CL)


def seek_current_limit(illuminationbin_seek_cl,gain_seek_cl,max_current_limit, PWflag, EnableSync):
    
    if EnableSync:
        WriteTps99000IlluminationSyncControl(DrvEnLowTime, SyncPW, sync_period) #Enable sync
    else:
        WriteTps99000IlluminationSyncControl(DrvEnLowTime, SyncPW, 0)   #Else disable sync
            
    WriteTps99000RgbLimits(max_current_limit,max_current_limit,max_current_limit)
    WriteIlluminationBinSelect(illuminationbin_seek_cl)
    sleep(0.05)
    green_CL = max_current_limit
    red_CL = max_current_limit
    blue_CL = max_current_limit
    
    init_DAC_min = 0
    init_DAC_max = 4095
    init_DAC = -1
    
    #Find a DAC level for which there are no errors. This DAC level is used as a known working DAC level when searching for a current limit.
    for dac in range(100,4100,100):
        WriteTps99000RgbDacLevels(0,dac,dac,dac)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(interval_time)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(interval_time)
        if(LsmNoCompareError == False and LsmPulseCountError == False and LsmPulseWidthError == False):
        #If no errors happen or only pulse width error happens and PWFlag is already set, use this DAC level
            init_DAC_min = dac
            for dac2 in range(init_DAC_min,4100,100):
                WriteTps99000RgbDacLevels(0,dac2,dac2,dac2)
                sleep(interval_time)
                WriteLedDriveErrors(True,True,True)
                sleep(interval_time)
                Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
                sleep(interval_time)
                if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True):
                    init_DAC_max = dac2
            init_DAC = int(((init_DAC_max - init_DAC_min) / 2) + init_DAC_min)
            break
    
    if init_DAC < 0:
        return 0, 0, 0 
    '''
    # Find current limit for red
    while red_CL > 1:
        WriteTps99000RgbDacLevels(0,4095,init_DAC,init_DAC)
        WriteTps99000RgbLimits(red_CL,max_current_limit,max_current_limit)
        WriteTps99000BlankingLevels(red_CL,max_current_limit,max_current_limit)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            red_CL = (red_CL/percent)* (1 + margin_percent)
            if red_CL > max_current_limit:
                red_CL = max_current_limit
            break
        else:
            red_CL = red_CL*percent

    # Find current limit for green
    while green_CL > 1:
        WriteTps99000RgbDacLevels(0,init_DAC,4095,init_DAC)
        WriteTps99000RgbLimits(red_CL,green_CL,max_current_limit)
        WriteTps99000BlankingLevels(red_CL,green_CL,max_current_limit)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            green_CL = (green_CL/percent) * (1 + margin_percent)
            if green_CL > max_current_limit:
                green_CL = max_current_limit
            break
        else:
            green_CL = green_CL*percent

    # Find current limit for blue
    while blue_CL > 1:
        WriteTps99000RgbDacLevels(0,init_DAC,init_DAC,4095)
        WriteTps99000RgbLimits(red_CL,green_CL,blue_CL)
        WriteTps99000BlankingLevels(red_CL,green_CL,blue_CL)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            blue_CL = (blue_CL/percent) * (1 + margin_percent)
            if blue_CL > max_current_limit:
                blue_CL = max_current_limit
            break
        else:
            blue_CL = blue_CL*percent
            
    
    green_CL, red_CL, blue_CL = round_up_to_nearest(round_up_to_nearest_number, red_CL, green_CL, blue_CL)
    
    
    # debug information for old method of testing 
    
    print("Illumnination Bin: " + str(illuminationbin_seek_cl));
    print("Gain: " + str(gain_seek_cl));
    
    print("Normal Red Limit: " + str(red_CL));
    
    print("Normal Green Limit: " + str(green_CL));
    
    print("Normal Blue Limit: " + str(blue_CL));
    '''
    
    
    
    # reset for some parallel testing 
    green_CL = max_current_limit
    red_CL = max_current_limit
    blue_CL = max_current_limit
    
    # Find current limits in parallel and reduce in parallel 
    while (red_CL > 1) and (green_CL > 1) and (blue_CL > 1):
        WriteTps99000RgbDacLevels(0,init_DAC,init_DAC,init_DAC)
        WriteTps99000RgbLimits(red_CL,green_CL,blue_CL)
        WriteTps99000BlankingLevels(red_CL,green_CL,blue_CL)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            red_CL = (red_CL/percent)* (1 + margin_percent)
            green_CL = (green_CL/percent)* (1 + margin_percent)
            blue_CL = (blue_CL/percent)* (1 + margin_percent)
            if red_CL > max_current_limit:
                red_CL = max_current_limit
            if green_CL > max_current_limit:
                green_CL = max_current_limit
            if blue_CL > max_current_limit:
                blue_CL = max_current_limit                
            
            break
        else:
            red_CL = red_CL*percent
            green_CL = green_CL*percent
            blue_CL = blue_CL*percent
    '''
    # Find current limit for green
    while green_CL > 1:
        WriteTps99000RgbDacLevels(0,init_DAC,4095,init_DAC)
        WriteTps99000RgbLimits(red_CL,green_CL,max_current_limit)
        WriteTps99000BlankingLevels(red_CL,green_CL,max_current_limit)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            green_CL = (green_CL/percent) * (1 + margin_percent)
            if green_CL > max_current_limit:
                green_CL = max_current_limit
            break
        else:
            green_CL = green_CL*percent

    # Find current limit for blue
    while blue_CL > 1:
        WriteTps99000RgbDacLevels(0,init_DAC,init_DAC,4095)
        WriteTps99000RgbLimits(red_CL,green_CL,blue_CL)
        WriteTps99000BlankingLevels(red_CL,green_CL,blue_CL)
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(0.017)
        Summary, LsmNoCompareError, LsmPulseCountError, LsmPulseWidthError = ReadLedDriveErrors()
        sleep(0.017)
        if(LsmNoCompareError == True or LsmPulseCountError == True or LsmPulseWidthError == True) :
            blue_CL = (blue_CL/percent) * (1 + margin_percent)
            if blue_CL > max_current_limit:
                blue_CL = max_current_limit
            break
        else:
            blue_CL = blue_CL*percent
            
    # corrective measures 
    if(gain_seek_cl = TiaGain.Gain36,TiaGain.Gain48,TiaGain.Gain72 ):
        if(red_CL < 100 && blue_CL > 600):
            
     '''               
    return round_up_to_nearest(round_up_to_nearest_number, red_CL, green_CL, blue_CL)


#------------------------------------------------------------------------------------------
#System Initialization
#------------------------------------------------------------------------------------------
WritePrepareForSourceChange()
WriteSourceSelect(InputSource.TestPatternGenerator)
WriteOperatingMode(OperatingMode.Display)
WriteDimmingLevel(65535)
WriteOperatingMode(OperatingMode.Calibration)
WriteTps99000RgbLimits(max_current_limit,max_current_limit,max_current_limit)
Summary, PhotoFeedbackModeEnable, CompoutLow, CmodeEnable = ReadTps99000DriveMode ( )
WriteTps99000DriveMode ( PhotoFeedbackModeEnable, CompoutLow, True )
sleep(1)
output = []
#-------------------------------------------------------------------------------------------


#First for each Illum bin / Gain combo determine whether sync needs to be used
for illumination_bin in range(min_DM_illumbin,max_illumbin + 1): #Start with brightest illum bin and iterate through all DM illum bins
    print "Setting Illumbin to {}".format(illumination_bin)
    WriteIlluminationBinSelect(illumination_bin)
    for gain in gains: #Start with lowest gain and iterate through all gains
        print "Setting Gain to {}".format(gain) 
        WriteTps99000Tia1Gain(gain) #Set Gain
        ES, DrvEnLowTime, SyncPW, SyncPer = ReadTps99000IlluminationSyncControl()
        WriteTps99000IlluminationSyncControl(DrvEnLowTime, SyncPW, 0) #Disable sync
        result = 0
        PWflag = 1	#If pulse width error exists even at a minimum usable level, this flag is set. It will be used later when determining the current limit
        WriteTps99000RgbLimits(max_current_limit,max_current_limit,max_current_limit)
        WriteTps99000RgbDacLevels(0,4095,4095,4095) #Set DAC levels to max
        sleep(interval_time)
        WriteLedDriveErrors(True,True,True)
        sleep(1)
        ES, NC, PC, PW = ReadLedDriveErrors()
        sleep(interval_time)
        if loglevel > 0:
            print "Without Sync"
            print    "NC = {}, PC = {}, PW = {}".format(LEDDriveError[NC],LEDDriveError[PC],LEDDriveError[PW]);
        if (NC == False and PC == False and PW == False): #If there are no LED drive errors with max DACs and no sync
            result = 2   #This combo can be used without sync  
        if (result == 0): #If this combo could not be used without sync, try using it with sync
            if loglevel > 0:
                print "Enabling Sync"
            WriteTps99000IlluminationSyncControl(DrvEnLowTime, SyncPW, sync_period) #Enable sync
            WriteLedDriveErrors(True, True, True)
            sleep(interval_time)
            for dac in range(0,4100,100):   #Start with low DACs and increase until pulse count and no compare errors are gone
                #This test could also be done by starting at max DAC and reducing DAC level
                WriteTps99000RgbDacLevels(0,dac,dac,dac)
                sleep(interval_time)
                ES, NC, PC, PW = ReadLedDriveErrors()
                sleep(interval_time)
                if loglevel > 0:
                    print "DACs set to {}".format(dac)
                    print    "NC = {}, PC = {}, PW = {}".format(LEDDriveError[NC],LEDDriveError[PC],LEDDriveError[PW]);
                if (NC == False and PC == False and PW == False): #If no compare error, pulse count error, and pulse width error do not occur this coarse combo can be used with sync
                    #If pulse width errors are heppening at with max CLs, it's likely that they will occur later when current limits are changed. Best to avoid these CCs
                    #Check both no compare error and pulse count error because when no compare error occurs, pulse count does not
                    #In the current configuration DAC level starts below the noise floor and increases. If the errors go away after DAC level reaches above the noise floor, this coarse combo can be used
                    result = 1
                    break
                WriteLedDriveErrors(True, True, True)
        combination_result = [illumination_bin, gain, results[result], PWflag]
        output.append(combination_result)


#For each combination from above determine the current limit
for result in output:
    if result[2] != "Cannot use": #If this combo is usable
        WriteIlluminationBinSelect(result[0])   #Set illum bin
        WriteTps99000Tia1Gain(result[1])        #Set Gain
        EnableSync = False
        if result[2] == "Can use with sync": #If this coarse combo requires sync
            EnableSync = True       
        green_CL, red_CL, blue_CL = seek_current_limit(result[0],result[1],max_current_limit, result[3],EnableSync)
        if ((green_CL == 0) or (red_CL == 0) or (blue_CL == 0)):
            result[2] = "Cannot Use";
            result.append(0)
            result.append(0)
            result.append(0)
        else:
            result.append(red_CL)
            result.append(green_CL)
            result.append(blue_CL)
                
    else :
        result.append(0)
        result.append(0)
        result.append(0)
    print "{},{},{},{},{},{}".format(result[0],result[1],result[2],result[4],result[5],result[6])

print "-------------------"
print "-------------------"
print "-------------------"
for result in output:
    if result[2] != "Cannot use":
        Sync = "0"
        if result[2] != "Can use without sync":
            Sync = "1"
        GainIndex = "{}".format(result[1]).strip('Gain').replace('p','.')
        print "<CoarseCombination><IlluminationBin>{}</IlluminationBin><Gain>{}</Gain><EnableSync>{}</EnableSync><RLimit>{}</RLimit><GLimit>{}</GLimit><BLimit>{}</BLimit></CoarseCombination>".format(result[0],GainIndex,Sync,result[4],result[5],result[6])        
